/*
   Copyright 2008-2009 Murali Krishnan

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

package com.notuvy.cmd;


import java.util.*;

/**
 * A set of commands that for a subset under a higher level of commands.
 *
 * User: murali
 * Date: Jan 2, 2008
 * Time: 2:04:45 PM
 */
public class CommandSubSet extends CommandSet {

    //------------------------------------------------------------
    //- Class Variables


    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables


    //------------------------------------------------------------
    //- Constructors

    public CommandSubSet(String pName) {
        super (pName);
    }

    //------------------------------------------------------------
    //- Getters


    //------------------------------------------------------------
    //- Settors



    //------------------------------------------------------------
    //- Private/Protected Utility Functions

    public List<String> listCommands() {
        List<String> preliminary = preliminaryCommands();
        List<String> result = new ArrayList<String>(preliminary.size());
        for (String string : preliminary) {
            result.add(getKey() + " " + string);
        }
        return result;
    }


    //------------------------------------------------------------
    //- Public Interface Functions


    //------------------------------------------------------------
    //- Class Interface Functions

    public boolean process(String[] pArgs) {
        LOG.error("Attempt to access a sub-command as a top-level command.");
        return false;
    }


    protected boolean handle(CommandArgs pArgs) {
        boolean valid = false;
        if (pArgs.isEmpty()) {
            LOG.error("Expected a subcommand for [" + getKey() + "].");
            LOG.error(toUsageString());
        } else {
            valid = processNext(pArgs);
        }
        return valid;
    }


    //------------------------------------------------------------
    //- Inner Classes

    //------------------------------------------------------------
    //- Main

}
