/*
   Copyright 2009 Murali Krishnan

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

package com.notuvy.cmd;

/**
 * An entity that is controlled by a CommandSet.
 * Implementors define how the CommandSet is configured.
 * After configuration, the logic is executed by calling run()
 * (which is inherited from Runnable).
 */
public interface Commandable extends Runnable {

    void configure(CommandSet pCommandSet);

}
