/*
   Copyright 2009 Murali Krishnan

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

package com.notuvy.cmd;

/**
 * An entity that is set up by arguments and then executed.
 * After setting up, the logic is executed by calling run() (which is
 * inherited from Runnable).
 * This is a much simpler mode of operation than Commandable/CommandSet.
 */
public interface SimpleExecutable extends Runnable {

    boolean setup(CommandArgs pCommandArgs);

}