package com.notuvy.condtrig;

import java.util.Iterator;

/**
 * The logical AND of multiple terms.
 *
 * @author murali
 */
public class And extends Composite {

    //------------------------------------------------------------
    //- Class Variables

    public static And of(Expression... pTerms) {
        return new And(pTerms);
    }


    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables


    //------------------------------------------------------------
    //- Constructors

    private And(Expression... pTerms) {
        super (pTerms);
    }


    //------------------------------------------------------------
    //- Gettors


    //------------------------------------------------------------
    //- Settors


    //------------------------------------------------------------
    //- Private/Protected Utility Functions


    //------------------------------------------------------------
    //- Public Interface Functions


    //------------------------------------------------------------
    //- Class Interface Functions

    protected String symbol() {
        return " && ";
    }

    protected void recalculate() {
        boolean allSet = true;  // Optimistic.
        Iterator<Expression> iterator = fTerms.iterator();
        while (allSet && iterator.hasNext()) {
            allSet = iterator.next().getValue();
        }
        setValue(allSet);
    }


    //------------------------------------------------------------
    //- Inner Classes


    //------------------------------------------------------------
    //- Main


}
