package com.notuvy.condtrig;

import java.util.List;
import java.util.ArrayList;

/**
 * An abstract expression consisting of multiple terms.
 *
 * @author murali
 */
public abstract class Composite extends Expression {

    //------------------------------------------------------------
    //- Class Variables


    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables

    protected final List<Expression> fTerms = new ArrayList<Expression>();


    //------------------------------------------------------------
    //- Constructors

    protected Composite(Expression... pTerms) {
        for (Expression term : pTerms) {
            add(term);
        }
    }


    //------------------------------------------------------------
    //- Gettors


    //------------------------------------------------------------
    //- Settors


    //------------------------------------------------------------
    //- Private/Protected Utility Functions


    //------------------------------------------------------------
    //- Public Interface Functions

    public void add(Expression pTerm) {
        fTerms.add(pTerm);
        pTerm.setParent(this);

        recalculate();
    }


    //------------------------------------------------------------
    //- Class Interface Functions

    protected abstract String symbol();

    @Override
    public String toString() {
        StringBuilder builder = new StringBuilder();
        builder.append("(");
        boolean first = true;
        for (Expression term : fTerms) {
            if (first) {
                first = false;
            } else {
                builder.append(symbol());
            }
            builder.append(term);
        }
        builder.append(")");
        return builder.toString();
    }


    //------------------------------------------------------------
    //- Inner Classes


    //------------------------------------------------------------
    //- Main

}
