package com.notuvy.condtrig;

import java.util.Iterator;

/**
 * The logical AND of multiple terms.
 *
 * @author murali
 */
public class Or extends Composite {

    //------------------------------------------------------------
    //- Class Variables

    public static Or of(Expression... pTerms) {
        return new Or(pTerms);
    }


    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables


    //------------------------------------------------------------
    //- Constructors

    private Or(Expression... pTerms) {
        super (pTerms);
    }


    //------------------------------------------------------------
    //- Gettors


    //------------------------------------------------------------
    //- Settors


    //------------------------------------------------------------
    //- Private/Protected Utility Functions


    //------------------------------------------------------------
    //- Public Interface Functions


    //------------------------------------------------------------
    //- Class Interface Functions

    protected String symbol() {
        return " || ";
    }

    protected void recalculate() {
        boolean allUnset = true;  // Pessimistic.
        Iterator<Expression> iterator = fTerms.iterator();
        while (allUnset && iterator.hasNext()) {
            allUnset = !iterator.next().getValue();
        }
        setValue(!allUnset);
    }


    //------------------------------------------------------------
    //- Inner Classes


    //------------------------------------------------------------
    //- Main


}
