/*
   Copyright 2006-2009 Murali Krishnan

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */

package com.notuvy.gui;

import java.awt.event.*;

import javax.swing.*;

import org.apache.log4j.Logger;

/**
 * A GUI widget to select true/false values.
 *
 * @author  murali
 */
public class BooleanChoice {

    //------------------------------------------------------------
    //- Class Variables

    protected static final Logger LOG = Logger.getLogger(BooleanChoice.class);

    private static final Boolean[] CHOICES = {Boolean.TRUE, Boolean.FALSE};


    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables

    private JComboBox vComboBox = new JComboBox(CHOICES);


    //------------------------------------------------------------
    //- Constructors

    public BooleanChoice() {
    }


    //------------------------------------------------------------
    //- Accessors

    public JComboBox getComboBox() {
        return vComboBox;
    }


    //------------------------------------------------------------
    //- Settors


    //------------------------------------------------------------
    //- Private/Protected Utility Functions



    //------------------------------------------------------------
    //- Public Interface Functions

    public boolean getValue() {
        Boolean value = (Boolean) getComboBox().getSelectedItem();
        boolean result = value.booleanValue();
        return result;
    }


    public void setValue(boolean pValue) {
        getComboBox().setSelectedItem(Boolean.valueOf(pValue));
    }


    //------------------------------------------------------------
    //- Class Interface Functions



    //------------------------------------------------------------
    //- Inner Classes



    //------------------------------------------------------------
    //- Main



}
