package com.notuvy.gui;

import com.notuvy.condtrig.Consequent;

import javax.swing.*;
import java.util.List;
import java.util.Arrays;
import java.util.ArrayList;

/**
 * A collection of components that are all enabled/disabled as a unit.
 *
 * @author murali
 */
public class ComponentEnableSet implements Consequent {

    //------------------------------------------------------------
    //- Class Variables


    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables

    private final List<JComponent> fComponents = new ArrayList<JComponent>();


    //------------------------------------------------------------
    //- Constructors

    public ComponentEnableSet(JComponent... pComponents) {
        add(pComponents);
    }

    //------------------------------------------------------------
    //- Gettors


    //------------------------------------------------------------
    //- Settors


    //------------------------------------------------------------
    //- Private/Protected Utility Functions


    //------------------------------------------------------------
    //- Public Interface Functions

    public ComponentEnableSet add(JComponent... pComponents) {
        fComponents.addAll(Arrays.asList(pComponents));
        return this;
    }

    public void setEnabled(boolean pState) {
        for (JComponent component : fComponents) {
            component.setEnabled(pState);
        }
    }

    //------------------------------------------------------------
    //- Class Interface Functions

    // Trigger consequent
    public void handle(boolean pValue) {
        setEnabled(pValue);
    }


    //------------------------------------------------------------
    //- Inner Classes


    //------------------------------------------------------------
    //- Main


}
