/*
   Copyright 2006-2009 Murali Krishnan

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */

package com.notuvy.gui;

import javax.swing.*;
import java.awt.*;

/**
 * Basic description
 *
 * @author  murali
 */
public class FormPanelCreator extends PanelCreator {

    //------------------------------------------------------------
    //- Class Variables


    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables

    private final FormFieldMap vFields;


    //------------------------------------------------------------
    //- Constructors

    public FormPanelCreator(FormFieldMap pFields) {
        vFields = pFields;
    }


    //------------------------------------------------------------
    //- Accessors

    public FormFieldMap getFields() {
        return vFields;
    }


    //------------------------------------------------------------
    //- Settors


    //------------------------------------------------------------
    //- Private/Protected Utility Functions


    //------------------------------------------------------------
    //- Public Interface Functions

    public JPanel createPanel() {
        JPanel result = new JPanel(new GridBagLayout());

        GridBagConstraints gbc = new GridBagConstraints();

        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbc.ipadx = 4;
        gbc.ipady = 4;
        gbc.gridwidth = 1;
        gbc.insets = new Insets(2, 5, 2, 5);

        int row = 0;

        for (FormField field : getFields().getFields()) {
            gbc.gridy = row;

            field.addTo(result, gbc);

            row += gbc.gridheight;
        }

        return result;
    }


    //------------------------------------------------------------
    //- Class Interface Functions



    //------------------------------------------------------------
    //- Inner Classes



    //------------------------------------------------------------
    //- Main



}
