/*
   Copyright 2007-2009 Murali Krishnan

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */

package com.notuvy.gui;

import java.awt.*;

import javax.swing.*;

import org.apache.log4j.Logger;

/**
 * Display an informational dialog with the given text.
 *
 * @author  murali
 */
public class InfoDialog {

    //------------------------------------------------------------
    //- Class Variables

    protected static final Logger LOG = Logger.getLogger(InfoDialog.class);


    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables

    private final String vContent;


    //------------------------------------------------------------
    //- Constructors

    public InfoDialog(Component pOwner, String pTitle, String pContent) {
        vContent = pContent;

        JOptionPane.showMessageDialog(pOwner,
                                      createMainPanel(),
                                      pTitle,
                                      JOptionPane.INFORMATION_MESSAGE);
    }


    //------------------------------------------------------------
    //- Accessors

    protected String getContent() {
        return vContent;
    }


    //------------------------------------------------------------
    //- Settors


    //------------------------------------------------------------
    //- Private/Protected Utility Functions

    protected JPanel createMainPanel() {
        JPanel result = new JPanel(new BorderLayout());


        JTextArea textarea = new JTextArea(getContent(), 20, 50);
        {
            textarea.setEditable(false);
            textarea.setLineWrap(true);
            textarea.setWrapStyleWord(true);
            textarea.setCaretPosition(0);
        }

        JScrollPane scrollPane = new JScrollPane(textarea);

        result.add(BorderLayout.CENTER, scrollPane);

        return result;
    }


    //------------------------------------------------------------
    //- Public Interface Functions



    //------------------------------------------------------------
    //- Class Interface Functions



    //------------------------------------------------------------
    //- Inner Classes



    //------------------------------------------------------------
    //- Main



}
