package com.notuvy.gui;

import com.notuvy.util.Progressable;

import javax.swing.*;

/**
 * Encapsulate a progress bar exposed as the Progressable interface.
 *
 * User: murali
 * Date: May 17, 2010
 * Time: 4:37:00 PM
 */
public class Progress implements Progressable {

    //------------------------------------------------------------
    //- Class Variables


    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables

    private final JProgressBar fProgressBar = new JProgressBar();


    //------------------------------------------------------------
    //- Constructors


    //------------------------------------------------------------
    //- Getters

    public JProgressBar getProgressBar() {
        return fProgressBar;
    }


    //------------------------------------------------------------
    //- Settors


    //------------------------------------------------------------
    //- Private/Protected Utility Functions


    //------------------------------------------------------------
    //- Public Interface Functions


    //------------------------------------------------------------
    //- Class Interface Functions

    public int getMinimum() {
        return getProgressBar().getMinimum();
    }

    public int getMaximum() {
        return getProgressBar().getMaximum();
    }

    public int getValue() {
        return getProgressBar().getValue();
    }

    public void setMinimum(int pValue) {
        getProgressBar().setMinimum(pValue);
    }

    public void setMaximum(int pValue) {
        getProgressBar().setMaximum(pValue);
    }

    public void setValue(int pValue) {
        getProgressBar().setValue(pValue);
    }

    public void incrementValue(int pValue) {
        getProgressBar().setValue(getProgressBar().getValue() + pValue);
    }

    public void setString(String pString) {
        if (!getProgressBar().isStringPainted()) {
            getProgressBar().setStringPainted(true);
        }

        getProgressBar().setString(pString);
    }

    public void start() {
        // NOOP.
    }

    public void finished() {
        // NOOP.
    }

    //------------------------------------------------------------
    //- Inner Classes


    //------------------------------------------------------------
    //- Main

}
