package com.notuvy.gui;

import org.apache.log4j.AppenderSkeleton;
import org.apache.log4j.Level;
import org.apache.log4j.spi.LoggingEvent;

import java.util.ArrayList;
import java.util.List;

/**
 * A log4j appender which writes to a GUI StatusBar.
 * When a StatusBar is instantiated, it automatically registers with this class so events get logged there.
 *
 * @author murali
 */
public class StatusBarAppender extends AppenderSkeleton {

    //------------------------------------------------------------
    //- Class Variables

    protected static List<StatusBar> STATUSES = new ArrayList<StatusBar>();


    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables


    //------------------------------------------------------------
    //- Constructors

    public StatusBarAppender() {
    }


    //------------------------------------------------------------
    //- Gettors


    //------------------------------------------------------------
    //- Settors


    //------------------------------------------------------------
    //- Private/Protected Utility Functions


    //------------------------------------------------------------
    //- Public Interface Functions

    protected void append(LoggingEvent event) {
        if (event.getLevel().isGreaterOrEqual(Level.INFO)) {
            String message = event.getMessage().toString();
            for (StatusBar statusBar : STATUSES) {
                statusBar.setText(message);
            }
        }
    }

    public boolean requiresLayout() {
        return false;
    }

    public void close() {
        // Nothing.
    }


    //------------------------------------------------------------
    //- Class Interface Functions


    //------------------------------------------------------------
    //- Inner Classes


    //------------------------------------------------------------
    //- Main


}
