/*
   Copyright 2006-2009 Murali Krishnan

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */

package com.notuvy.gui;

import java.awt.BorderLayout;
import java.awt.GridLayout;

import javax.swing.*;

/**
 * Basic description
 *
 * @author  murali
 */
public abstract class StripPanelCreator extends PanelCreator {

    //------------------------------------------------------------
    //- Class Variables


    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables



    //------------------------------------------------------------
    //- Constructors


    //------------------------------------------------------------
    //- Accessors



    //------------------------------------------------------------
    //- Settors


    //------------------------------------------------------------
    //- Private/Protected Utility Functions


    //------------------------------------------------------------
    //- Public Interface Functions

    public StripPanelCreator add(JComponent pComponent) {
        getEntries().add(pComponent);

        return this;
    }


    public JPanel createPanel() {
        JPanel result = new JPanel(new BorderLayout());
        {
            JPanel array = new JPanel(createGridLayout());
            for (JComponent button : getEntries()) {
                array.add(button);
            }

            result.add(array, giveOrientation());
        }

        return result;
    }


    //------------------------------------------------------------
    //- Class Interface Functions

    protected abstract GridLayout createGridLayout();
    protected abstract String giveOrientation();


    //------------------------------------------------------------
    //- Inner Classes

    public static class Horizontal extends StripPanelCreator {

        protected GridLayout createGridLayout() {
            return new GridLayout(1, getEntries().size());
        }

        protected String giveOrientation() {
            return BorderLayout.EAST;
        }

    }

    public static class Vertical extends StripPanelCreator {

        protected GridLayout createGridLayout() {
            return new GridLayout(getEntries().size(), 1);
        }

        protected String giveOrientation() {
            return BorderLayout.NORTH;
        }

    }


    //------------------------------------------------------------
    //- Main



}
