/*
   Copyright 2007-2009 Murali Krishnan

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */

package com.notuvy.gui;

import java.awt.Component;

import javax.swing.JDialog;
import javax.swing.JOptionPane;

/**
 * A warning dialog that is displayed only for a limited amount of time.
 *
 * @author  murali
 */
public class TimedWarnDialog extends TimedDialog {

    //------------------------------------------------------------
    //- Class Variables



    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables



    //------------------------------------------------------------
    //- Constructors

    public TimedWarnDialog(Component pParent, String pTitle, String pMessage, int pSeconds) {
        super (pParent, pTitle, pMessage, (pSeconds * 1000));
    }


    //------------------------------------------------------------
    //- Accessors



    //------------------------------------------------------------
    //- Settors



    //------------------------------------------------------------
    //- Private/Protected Utility Functions



    //------------------------------------------------------------
    //- Public Interface Functions



    //------------------------------------------------------------
    //- Class Interface Functions

    protected JOptionPane createOptionPane() {
        JOptionPane result = new JOptionPane(getMessage(), JOptionPane.WARNING_MESSAGE);

        return result;
    }


    //------------------------------------------------------------
    //- Inner Classes



    //------------------------------------------------------------
    //- Main

    public static void main(String[] args) {
        try {
            TimedWarnDialog dialog = new TimedWarnDialog(null, "Title", "Warning Message", 15);
            dialog.show();
            System.exit(0);
        } catch (Throwable thr) {
            LOG.error("Fatal error.", thr);
        }
    }


}
