/*
   Copyright 2006-2009 Murali Krishnan

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */

package com.notuvy.image;

import java.io.File;
import java.text.DecimalFormat;

/**
 * 
 * 
 * @author  murali
 * @version  $Id: AlbumImage.java,v 1.1 2006/06/22 04:01:59 murali Exp $
 */
public class AlbumImage {

    //------------------------------------------------------------
    //- Class Variables


    protected static final DecimalFormat FORMAT_IMAGE_NUMBER = new DecimalFormat("img0000.jpg");


    //------------------------------------------------------------
    //- Class Functions



    //------------------------------------------------------------
    //- Instance Variables

    private final SourceImage vSource;
    private final int vMaxDimension;
    private final String vFilename;


    //------------------------------------------------------------
    //- Constructors

    protected AlbumImage(SourceImage pSource, int pMaxDimension, DecimalFormat pFormat, int pIndex) {
        vSource = pSource;
        vMaxDimension = pMaxDimension;
        vFilename = pFormat.format(pIndex);
    }


    //------------------------------------------------------------
    //- Accessors

    protected SourceImage getSource() {
        return vSource;
    }

    protected int getMaxDimension() {
        return vMaxDimension;
    }

    public String getFilename() {
        return vFilename;
    }



    //------------------------------------------------------------
    //- Settors



    //------------------------------------------------------------
    //- Private/Protected Utility Functions



    //------------------------------------------------------------
    //- Public Interface Functions

    public void save(File pParent) {
        ScaledImage scaled = new ScaledImage(getSource().getImage(), getMaxDimension());
        File file = new File(pParent, getFilename());
        SourceImage target = new SourceImage(file, scaled.getImage());
        target.save();
        target.clear();
        scaled.clear();
    }


    //------------------------------------------------------------
    //- Class Interface Functions



    //------------------------------------------------------------
    //- Inner Classes



    //------------------------------------------------------------
    //- Main



}
