package com.notuvy.podcast;

import org.apache.log4j.Logger;
import org.jdom.Element;
import org.jdom.Namespace;
import com.notuvy.xml.SimpleJdom;

/**
 * Basic description
 *
 * @author murali
 */
public abstract class PodcastBase extends SimpleJdom {

    //------------------------------------------------------------
    //- Class Variables

    protected static final Logger LOG = Logger.getLogger("com.notuvy.podcast");

    protected static Namespace gNsItunes = null;


    //------------------------------------------------------------
    //- Class Functions

    protected static String getTextFromElement(Element pElement) {
        String result = "";  // fallback
        if (pElement != null) {
            result = pElement.getText();
        }
        return result;
    }

    //------------------------------------------------------------
    //- Instance Variables

    private String fSiteUrl;
    private String fTitle;
    private String fDescription;


    //------------------------------------------------------------
    //- Constructors

    protected PodcastBase() {
    }

    protected PodcastBase(String pTitle, String pLink, String pDesc) {
        setTitle(pTitle);
        setSiteUrl(pLink);
        setDescription(pDesc);
    }

    //------------------------------------------------------------
    //- Accessors

    public String getSiteUrl() {
        return fSiteUrl;
    }

    public String getTitle() {
        return fTitle;
    }

    public String getDescription() {
        return fDescription;
    }


    //------------------------------------------------------------
    //- Settors

    protected void setSiteUrl(String pSiteUrl) {
        fSiteUrl = pSiteUrl;
    }

    protected void setTitle(String pTitle) {
        fTitle = pTitle;
    }

    protected void setDescription(String pDescription) {
        fDescription = pDescription;
    }


    //------------------------------------------------------------
    //- Private/Protected Utility Functions


    //------------------------------------------------------------
    //- Public Interface Functions


    //------------------------------------------------------------
    //- Class Interface Functions


    //------------------------------------------------------------
    //- Inner Classes


    //------------------------------------------------------------
    //- Main


}
