/*
   Copyright 2006-2009 Murali Krishnan

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

package com.notuvy.util;

/**
 * Trivial implementation.  Just a value holder.
 *
 * @author  murali
 */
public class DummyProgress implements Progressable {

    //------------------------------------------------------------
    //- Class Variables



    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables

    private int vMinimum = 0;
    private int vMaximum = 0;
    private int vValue = 0;


    //------------------------------------------------------------
    //- Constructors


    //------------------------------------------------------------
    //- Accessors

    public int getMinimum() {
        return vMinimum;
    }

    public int getMaximum() {
        return vMaximum;
    }

    public int getValue() {
        return vValue;
    }


    //------------------------------------------------------------
    //- Settors

    public void setMinimum(int pMinimum) {
        vMinimum = pMinimum;
    }

    public void setMaximum(int pMaximum) {
        vMaximum = pMaximum;
    }

    public void setValue(int pValue) {
        vValue = pValue;
    }


    //------------------------------------------------------------
    //- Private/Protected Utility Functions


    //------------------------------------------------------------
    //- Public Interface Functions

    public String toString() {
        int remaining = getMaximum() - getValue();
        return getValue() + "/" + getMaximum() + ", " + remaining + " remaining";
    }


    //------------------------------------------------------------
    //- Class Interface Functions

    public void incrementValue(int pValue) {
        setValue(pValue + getValue());
    }

    public void setString(String pText) {
        // NOOP.
    }

    public void start() {
        // NOOP.
    }

    public void finished() {
        // NOOP.
    }


    //------------------------------------------------------------
    //- Inner Classes



    //------------------------------------------------------------
    //- Main



}
