/*
   Copyright 2006-2009 Murali Krishnan

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

package com.notuvy.util;

/**
 * An entity that keeps track of progress status.
 *
 * @author  murali
 */
public interface Progressable {

    //------------------------------------------------------------
    //- Class Variables


    //------------------------------------------------------------
    //- Class Interface Functions

    int getMinimum();
    int getMaximum();
    int getValue();

    void setMinimum(int pValue);
    void setMaximum(int pValue);
    void setValue(int pValue);
    void incrementValue(int pValue);
    void setString(String pString);

    void start();
    void finished();
}
