/*
   Copyright 2008-2009 Murali Krishnan

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */

package com.notuvy.util;

/**
 * An abstract variable that just has get/set.
 * This is usefule when a final variable is needed, but the contents need to be changed.
 *
 * User: murali
 * Date: Apr 23, 2009
 * Time: 8:55:21 AM
 */
public class ValueHolder<T> {

    //------------------------------------------------------------
    //- Class Variables


    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables

    private T fValue;

    //------------------------------------------------------------
    //- Constructors

    public ValueHolder(T pValue) {
        set(pValue);
    }

    //------------------------------------------------------------
    //- Getters

    public T get() {
        return fValue;
    }

    //------------------------------------------------------------
    //- Settors

    public void set(T pValue) {
        fValue = pValue;
    }


    //------------------------------------------------------------
    //- Private/Protected Utility Functions


    //------------------------------------------------------------
    //- Public Interface Functions


    //------------------------------------------------------------
    //- Class Interface Functions

    @Override
    public String toString() {
        return "ValueHolder[" + get() + "]";
    }

    //------------------------------------------------------------
    //- Inner Classes


    //------------------------------------------------------------
    //- Main

}
